package org.test.as7.cdi;

import javax.inject.Inject;

import junit.framework.Assert;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.logging.Logger;
import org.jboss.logging.Logger.Level;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.EmptyAsset;
import org.jboss.shrinkwrap.api.spec.WebArchive;
import org.junit.Test;
import org.junit.runner.RunWith;

@RunWith(Arquillian.class)
public class SimpleCDITest {

    private static Logger logger = Logger
            .getLogger(SimpleCDITest.class);

    @Deployment()
    public static Archive<?> createDeployment() {
        return ShrinkWrap
                .create(WebArchive.class, "test.war")
                .addPackages(true, "org.test.as7.cdi")
                .addAsWebInfResource(EmptyAsset.INSTANCE, "beans.xml");
    }

    @Inject
    private InjectableEJB1 injectableEJB1;

    @Test
    public void injectedManagedBeanDependencyTest() {

        logger.logv(Level.INFO, "injectedDependenciesTest");

        Assert.assertNotNull(injectableEJB1.getSimpleBean());
        Assert.assertNotNull(injectableEJB1.getSimpleEJB());
    }

    @Test
    public void instantiatedBeanDependencyTest() {

        logger.logv(Level.INFO, "instantiatedBeanDependencyTest");

        final InjectableEJB2 injectableEJB2 = new InjectableEJB2();
        // Injected dependencies into InjectableEJB2 are null...
        // ... fails
        //Assert.assertNotNull(injectableEJB2.getSimpleBean());
        //Assert.assertNotNull(injectableEJB2.getSimpleEJB());
        logger.logv(Level.INFO, "SimpleBean: {0}, SimpleEJB: {1}",
                injectableEJB2.getSimpleBean(),
                injectableEJB2.getSimpleEJB());
    }
}
